/* ----------------------------------------------------------
%   (C)1993,1994,1995 Institute for New Generation Computer Technology
%       (Read COPYRIGHT for detailed information.)
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GC_MACRO_H_
#define _KLIC_GC_MACRO_H_

#include <klic/stdc.h>  /* CONCATENATE */
#include <klic/basic.h>  /* fatal, debug_printf, klic_fprintf, klic_putc */
#include <klic/g_basic.h>

/* runtime/unify.c */
extern void set_rest_of_stream(q term);

/* runtime/generic.c */
extern q GC_MAKE_HOOK_VAR(struct consumer_object* obj);

#define    GC_RETURN_WITH_HOOK(x) \
do{ \
  set_rest_of_stream(x); \
  return; \
}while(0)

#define GC_TERMINATE \
do{ \
  set_rest_of_stream(NULL); \
  return; \
}while(0)

/***************************************************************************/

#define GC_TRY_TO_ALLOC(new, type, size, gc_request) \
do{ \
  q res; \
  G_HEAPALLOC_WITH_CHECK((new), (size), type, res); \
  if (res == GENERIC_GCREQUEST) goto gc_request; \
}while(0)

/**********************************************************************/

#define GCDEF_UNIFY() \
static void G_rappend(active_unify) (G_OBJ_TYPE* g_self, q g_term)

/*******************************************/

#define GCSET_MESSAGE(message)					\
do{								\
  (message) = car_of(g_term);				\
  while( isref(message) ){					\
    q temp = derefone(message);				\
    if( isref(temp) &&					\
	(temp == (message) || derefone(temp) == (message))) {	\
      reason = (message);					\
      g_self->stream = g_term;				\
      goto suspend;						\
    } else {							\
      (message) = temp;						\
    }								\
  }								\
}while(0)

#define GCSET_MESSAGE_INT_ARG(_arg, message, pos)		\
do{								\
  q temp = arg((message), (pos));				\
  while( !isint(temp) ){					\
    if( isref(temp) ){					\
      q temp1 = derefone(temp);				\
      if( isref(temp1) && derefone(temp1) == temp ){	\
	reason = temp1;						\
	g_self->stream = g_term;				\
	goto suspend;						\
      }								\
      temp = temp1;						\
    } else {							\
      goto message_error;					\
    }								\
  }								\
  (_arg) = intval(temp);					\
}while(0)

#define GCSET_MESSAGE_STR_ARG(_arg, message, pos)		\
do{								\
  q temp = arg((message), (pos));				\
  while (!G_ISGOBJ(temp) ||					\
	 (struct data_object_method_table *)			\
	 functor_of(temp) !=					\
	 &byte__string_g_method_table) {			\
    if( isref(temp) ){					\
      q temp1 = derefone(temp);				\
      if( isref(temp1) && derefone(temp1) == temp ){	\
	reason = temp1;						\
	g_self->stream = g_term;				\
	goto suspend;						\
      }								\
      temp = temp1;						\
    } else {							\
      goto message_error;					\
    }								\
  }								\
  (_arg) = (struct byte_string_object*) functorp(temp);	\
}while(0)

#define GCSET_VAR(self)  ((self) = makeref(&(self)))

#endif /* _KLIC_GC_MACRO_H_ */
