/* ---------------------------------------------------------- 
%   (C)1993,1994 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

/*
  module data type

+---------+
| methd   |
+---------+
| symbol  |
+---------+
*/

#include <stdio.h>
#include <klic/gdobject.h>
#include <klic/predinfo.h>
#include "atom.h"
#include "funct.h"

#define CLASS_NAME  module
#define G_OBJ_TYPE  struct module_object
#define G_OBJ_SIZE  ((sizeof(struct module_object)) / sizeof(q))

#include <klic/gd_macro.h>
#include <klic/gmodule.h>

extern const struct modinfo defined_modules[];
extern struct predicate* locate_predicate_in_module();

/* basic method definitions */

GDDEF_GUNIFY()
{
  G_STD_DECL;

  if (g_self->method_table != GD_OTHER->method_table ||
      g_self->name != GD_OTHER->name)
    GD_GFAIL;
  else
    GD_GSUCCEED;
}


GDDEF_UNIFY()
{
  G_STD_DECL;

  if (g_self->method_table != GD_OTHER->method_table ||
      g_self->name != GD_OTHER->name)
    GD_UNIFY_FAIL;
}

G_DEF_GC()
{
  G_STD_DECL;
  G_OBJ_TYPE* newself;

  G_SET_NEWOBJ_IN_NEWGEN(newself);
  newself->name = g_self->name;
  G_RETURN_FROM_GC(newself);
}

/* Generic method */

GDDEF_METHOD(name_1)
{
  G_STD_DECL;
  do_shallow_unify(g_argv[0], g_self->name);
}


GDDEF_GENERIC()
{
  G_STD_DECL;

  GD_SWITCH_ON_METHOD {
    GD_METHOD_CASE(name_1);
    GD_METHOD_CASE_DEFAULT;
  }
}

G_DEF_PRINT()
{
  G_STD_DECL;
  G_PRINT("<MODULE#");
  GD_PRINT_KL1_TERMS(g_self->name, 0, 1);
  G_PRINT(">");
  G_RETURN_FROM_PRINT();
}

GDDEF_GMETHOD(module_0)
{
 G_STD_DECL;
 GD_GSUCCEED;
}

GDDEF_GMETHOD(defined_2)
{
 G_STD_DECL;
 q predname = g_argv[0];
 q arity = g_argv[1];

 GD_GDEREF(predname);
 if( !issym(predname) ) GD_GFAIL;
 GD_GDEREF(arity);
 if( !isint(arity) || intval(arity) < 0 ) GD_GFAIL;
 if( locate_predicate_in_module(g_self->name, predname,
				intval(arity)) != NULL ){
   GD_GSUCCEED;
 } else {
   GD_GFAIL;
 }
}

GDDEF_GGENERIC()
{
  G_STD_DECL;

  GD_SWITCH_ON_METHOD {
    GD_GMETHOD_CASE(module_0);
    GD_GMETHOD_CASE(defined_2);
    GD_GMETHOD_CASE_DEFAULT;
  }
}

#define GDUSE_MY_GUNIFY
#define GDUSE_MY_UNIFY
#define GDUSE_MY_PRINT
#define GDUSE_MY_GC
#define GDUSE_MY_GENERIC
#define GDUSE_MY_GGENERIC

/* define the method table structure of the vector */
#include <klic/gd_methtab.h>

/*  new_module function */
/*
  The argument is only one and it's the name of the module
*/

G_DEF_NEW()
{
  G_STD_DECL_FOR_NEW();
  q atom;
  const struct modinfo* mp;
  unsigned char *name;

  GDSET_SYMARG_FOR_NEW(atom, g_argv[0]);
  name = namestringof(atom);
  for (mp = defined_modules; mp->name != 0; mp++) {
    if (strcmp((char *)mp->name, (char *)name) == 0) {
      G_OBJ_TYPE* newmodule;
      G_SET_NEWOBJ_FOR_NEW(newmodule, sizeof(struct module_object));
      newmodule->name = atom;
      GD_RETURN_FROM_NEW(newmodule);
    }
  }
  /* not found: return the name atom itself */
  GD_RETURN_FROM_NEW(atom);
}
