/* ---------------------------------------------------------- 
%   (C)1993,1994 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#include <klic/gdobject.h>
#include "g_pointer.h"

#define CLASS_NAME  pointer
#define G_OBJ_TYPE  struct pointer_object
#define G_OBJ_SIZE  (G_SIZE_IN_Q(G_OBJ_TYPE))

#include <klic/gd_macro.h>


GDDEF_GUNIFY()
{
  G_STD_DECL;

  if (g_self->method_table != GD_OTHER->method_table) GD_GFAIL;
  if (g_self->pointer != GD_OTHER->pointer) GD_GFAIL;
  GD_GSUCCEED;
}

GDDEF_UNIFY()
{
  G_STD_DECL;

  if (g_self->method_table != GD_OTHER->method_table) GD_UNIFY_FAIL;
  if (g_self->pointer != GD_OTHER->pointer) GD_UNIFY_FAIL;
}

G_DEF_GC()
{
  G_STD_DECL;
  G_OBJ_TYPE* newself;

  G_SET_NEWOBJ_IN_NEWGEN(newself);
  newself->pointer = g_self->pointer;
  G_RETURN_FROM_GC(newself);
}

#define GDUSE_MY_GUNIFY
#define GDUSE_MY_UNIFY
#define GDUSE_MY_GC

#include <klic/gd_methtab.h>

G_DEF_NEW()
{
  G_STD_DECL_FOR_NEW();
  G_OBJ_TYPE* newobj;

  if (g_argc != 1) fatal("Argument mismatch in pointer:new");

  newobj = (G_OBJ_TYPE*) klic_alloc(G_OBJ_SIZE);
  newobj->method_table = &G_method_table;
  newobj->pointer = (char*) g_argv[0];
  GD_RETURN_FROM_NEW(newobj);
}

extern q
gd_new_pointer(arg0)
     q arg0;
{
  q argv[1];
  argv[0] = arg0;
  return pointer_g_new(1, argv);
}
