/* ---------------------------------------------------------- 
%   (C)1993,1994 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#include <klic/gdobject.h>
#include "g_termarray.h"

#define CLASS_NAME  termarray
#define G_OBJ_TYPE  struct termarray_object
#define G_OBJ_SIZE  (G_SIZE_IN_Q(G_OBJ_TYPE) + g_self->nterm - 1)

#include <klic/gd_macro.h>

GDDEF_GUNIFY()
{
  G_STD_DECL;

  if (g_self->method_table != GD_OTHER->method_table) GD_GFAIL;
  if (g_self->terms != GD_OTHER->terms) GD_GFAIL;
  if (g_self->nterm != GD_OTHER->nterm) GD_GFAIL;
  GD_GSUCCEED;
}

GDDEF_UNIFY()
{
  G_STD_DECL;

  if (g_self->method_table != GD_OTHER->method_table) GD_UNIFY_FAIL;
  if (g_self->terms != GD_OTHER->terms) GD_UNIFY_FAIL;
  if (g_self->nterm != GD_OTHER->nterm) GD_UNIFY_FAIL;
}

G_DEF_GC()
{
  G_STD_DECL;
  unsigned long size = g_self->nterm;
  G_OBJ_TYPE* newself;
  unsigned long i;

  G_SET_NEWOBJ_IN_NEWGEN(newself);
  newself->nterm = size;
  for (i=0; i < size; i++) {
    G_COPY_KL1_TERM_TO_NEWGEN(g_self->terms[i],newself->terms[i]);
  }
  G_RETURN_FROM_GC(newself);
}

#define GDUSE_MY_GUNIFY
#define GDUSE_MY_UNIFY
#define GDUSE_MY_GC

#include <klic/gd_methtab.h>

G_DEF_NEW()
{
  G_STD_DECL_FOR_NEW();
  unsigned long size = g_argc;
  G_OBJ_TYPE* newobj;
  int i;

  newobj = (G_OBJ_TYPE*) klic_alloc(G_SIZE_IN_Q(G_OBJ_TYPE) + size - 1);
  newobj->method_table = &G_method_table;
  newobj->nterm = size;
  for (i=0; i<size; i++) {
    newobj->terms[i] = g_argv[i];
  }
  GD_RETURN_FROM_NEW(newobj);
}
